## ncbi-vdb 2.8.1+dfsg

=== libs/kfs/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: all

TOP ?= $(abspath ../..)
MODULE = libs/kfs

INT_LIBS = \
	libkfs \
	libkfs-nommap \
	libkff \

ALL_LIBS = \
	$(INT_LIBS)

OBJFILES =           \
	$(KFS_OBJ)       \
	$(KFS_NOMMAP_OBJ)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs compile
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# mmap.c
#  special rule to generate a disabled mmap
#
%.nommap.$(LOBX): %.c
	$(CC) -o $@ -fPIC $(OPT) -DFORCE_MALLOC_MMAP -D_LIBRARY $<


#-------------------------------------------------------------------------------
# kfs
#
$(ILIBDIR)/libkfs: $(addprefix $(ILIBDIR)/libkfs.,$(ILIBEXT))

$(ILIBDIR)/libkfs-nommap: $(addprefix $(ILIBDIR)/libkfs-nommap.,$(LIBX))

KFS_CMN = \
	directory \
	arrayfile \
	file \
	sysdir \
	sysfile \
	sysmmap \
	syslockfile \
	sysdll \
	gzip \
	bzip \
	md5 \
	crc32 \
	arc \
	toc \
	tocentry \
	tocdir \
	tocfile \
	sra \
	tar \
	teefile \
	buffile \
	buffile-read \
	buffile-write \
	subfile \
	nullfile \
	countfile \
	dir_test \
	pagefile \
	pmem \
	readheadfile \
	ramfile \
	extendable-ramfile \
	quickmount \
	report \
	lockfile \
	syslockfile \
	cacheteefile \
	from_to_namelist

KFS_SRC = \
	mmap \
	$(KFS_CMN)

ifeq (win,$(OS))
	KFS_SRC += directory-path
endif

KFS_NOMMAP_SRC = \
	mmap.nommap \
	$(KFS_CMN)

KFS_OBJ = \
	$(addsuffix .$(LOBX),$(KFS_SRC))

KFS_NOMMAP_OBJ = \
	$(addsuffix .$(LOBX),$(KFS_NOMMAP_SRC))

KFS_LIB = \
	-dkproc \
	-dklib \
	-ddl \
	-dz \
	-dbz2

#	-dsz \

$(ILIBDIR)/libkfs.$(LIBX): $(KFS_OBJ)
	$(LD) --slib -o $@ $^ $(KFS_LIB)

$(ILIBDIR)/libkfs-nommap.$(LIBX): $(KFS_NOMMAP_OBJ)
	$(LD) --slib -o $@ $^ $(KFS_LIB)



#-------------------------------------------------------------------------------
# kfs.2
#
$(ILIBDIR)/libkfs.2: $(addprefix $(ILIBDIR)/libkfs.2.,$(ILIBEXT))

KFS2_SRC = \
	$(KFS_SRC) \
	file-v2 \
	directory-v2 \
	sysfile-v2 
#	sysdir-v2

KFS2_OBJ = \
	$(addsuffix .$(LOBX),$(KFS2_SRC))

KFS2_LIB = \
	$(KFS_LIB)

$(ILIBDIR)/libkfs.2.$(LIBX): $(KFS2_OBJ)
	$(LD) --slib -o $@ $^ $(KFS2_LIB)


#-------------------------------------------------------------------------------
# kff
#
ifeq (1,$(HAVE_MAGIC))

$(ILIBDIR)/libkff: $(addprefix $(ILIBDIR)/libkff.,$(ILIBEXT))

OBJFILES += $(KFF_OBJ)

KFF_SRC = \
	fileformat \
	ffext \
	ffkey \
	ffmagic

KFF_OBJ = \
	$(addsuffix .$(LOBX),$(KFF_SRC))

KFF_LIB = \
	-dkfg \
	-dklib

ifneq (win,$(OS))
	KFF_LIB += -lmagic
endif

$(ILIBDIR)/libkff.$(LIBX): $(KFF_OBJ)
	$(LD) --slib -o $@ $^ $(KFF_LIB)

else

$(ILIBDIR)/libkff:
	@ echo "NOTE - internal library $(@F) cannot be built:"         \
	       "It requires 'libmagic' and its development headers."

endif

compile: stdcompile

$(TARGDIR)/compile: $(OBJFILES)

=== test/kns/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: runtests

TOP ?= $(abspath ../..)
MODULE = test/kns

TEST_TOOLS = \
	KNSManagerSingletonTest \
	test-kns \
	test-proxy \
	test-http \
	test-http-dropconn \

include $(TOP)/build/Makefile.env

EXT_TOOLS = \
	test-proxy-with-env

ALL_TOOLS = \
	$(INT_TOOLS) \
	$(EXT_TOOLS)

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs
	@ $(MAKE_CMD) $(TARGDIR)/$@

$(ALL_TOOLS): makedirs
	@ $(MAKE_CMD) $(BINDIR)/$@

.PHONY: all std $(ALL_TOOLS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(BINDIR)/,$(EXT_TOOLS))

$(TEST_TOOLS): makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@

clean: stdclean

INCDIRS += -I$(TOP)/libs/kns

#-------------------------------------------------------------------------------
# white-box test. TODO: combine with the old test/kns/http-test.c, roll into the C++ test-http
#
#
#TEST_SRC = \
#	wb-http-test
#
#TEST_OBJ = \
#	$(addsuffix .$(OBJX),$(TEST_SRC))
#
#TEST_LIB = \
#	-skapp-norsrc \
#	-sncbi-vdb \
#
#$(TEST_BINDIR)/test-http: $(TEST_OBJ)
#	$(LD) --exe -o $@ $^ $(TEST_LIB)

KNSTEST_LIB = \
	-skapp \
    -sncbi-vdb \
    -sktst \

#----------------------------------------------------------------
# KNSManagerSingletonTest
#
SINGLETON_SRC = \
	KNSManagerSingletonTest
SINGLETON_OBJ = \
	$(addsuffix .$(OBJX),$(SINGLETON_SRC))
$(TEST_BINDIR)/KNSManagerSingletonTest: $(SINGLETON_OBJ)
	$(LP) --exe -o $@ $^ $(KNSTEST_LIB)

#----------------------------------------------------------------
# test-kns
#
KNSTEST_SRC = \
	knstest

KNSTEST_OBJ = \
	$(addsuffix .$(OBJX),$(KNSTEST_SRC))

$(TEST_BINDIR)/test-kns: $(KNSTEST_OBJ)
	$(LP) --exe -o $@ $^ $(KNSTEST_LIB)

kns: test-kns 
	$(TEST_BINDIR)/test-kns  #-l=all

#----------------------------------------------------------------
# test-proxy
#
PROXYTEST_SRC = \
	http-client \
	test-proxy \

PROXYTEST_OBJ = \
	$(addsuffix .$(OBJX),$(PROXYTEST_SRC))

$(TEST_BINDIR)/test-proxy: $(PROXYTEST_OBJ)
	$(LP) --exe -o $@ $^ $(KNSTEST_LIB)
    
#----------------------------------------------------------------
# test-http
#
HTTPTEST_SRC = \
	httptest

HTTPTEST_OBJ = \
	$(addsuffix .$(OBJX),$(HTTPTEST_SRC))

$(TEST_BINDIR)/test-http: $(HTTPTEST_OBJ)
	$(LP) --exe -o $@ $^ $(KNSTEST_LIB)

http: test-http  
	$(TEST_BINDIR)/test-http  # -l=all
    
#----------------------------------------------------------------
# test-http-dropconn
#
HTTP_DROPCONN_TEST_SRC = \
	http_dropconnection_test

HTTP_DROPCONN_TEST_OBJ = \
	$(addsuffix .$(OBJX),$(HTTP_DROPCONN_TEST_SRC))

$(TEST_BINDIR)/test-http-dropconn: $(HTTP_DROPCONN_TEST_OBJ)
	$(LP) --exe -o $@ $^ $(KNSTEST_LIB)

dropconn: test-http-dropconn  
	$(TEST_BINDIR)/test-http-dropconn  # -l=all
    
#----------------------------------------------------------------
# test-proxy-with-env
# 
TOOL_SRC = \
	http-client \
	test-proxy-with-env \

TOOL_OBJ = \
	$(addsuffix .$(OBJX),$(TOOL_SRC))

$(BINDIR)/test-proxy-with-env: $(TOOL_OBJ)
	$(LP) --exe -o $@ $^ -L$(VDB_LIBDIR) -L$(VDB_LIBDIR)/../ilib $(KNSTEST_LIB)

=== test/ngs/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/ngs

TEST_TOOLS = \
    test-ngs \
    test-ngs_sra \
 	test-ngs_sradb \
 	test-ngs_csra1 \
 	test-ngs_csra1_readcollection \
    test-ngs_csra1_refwin \
    test-ngs_csra1_pileup \
    test-ngs_reference \
    test-ngs_fragmentblob \

include $(TOP)/build/Makefile.env


# make sure runs are not cached in the user repository when running tests
ifeq ($(wildcard ../../../asm-trace),)
	ifeq (,$(VDB_CONFIG))
		VDB_CONFIG = $(shell pwd)/../only-remote-repository.kfg
	endif
endif

$(TEST_TOOLS) $(SLOW_TEST_TOOLS): makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@

.PHONY: $(TEST_TOOLS) $(SLOW_TEST_TOOLS)

clean: stdclean

#-------------------------------------------------------------------------------
# common definitions
#
INCDIRS +=  -I$(TOP)/libs/ngs

TEST_NGS_LIB = \
	-sncbi-vdb \
	-skapp \
    -sktst

#-------------------------------------------------------------------------------
# ngs-makedb
# Create test databases for use in other suites
NGS_MAKEDB_SRC = \
	ngstest_makedb

NGS_MAKEDB_OBJ = \
	$(addsuffix .$(OBJX),$(NGS_MAKEDB_SRC))

NGS_MAKEDB_LIB = \
    -skapp \
	-sktst \
    -sncbi-wvdb

$(TEST_BINDIR)/ngs-makedb: $(NGS_MAKEDB_OBJ)
	$(LP) --exe -o $@ $^ $(NGS_MAKEDB_LIB)

makedb: $(TEST_BINDIR)/ngs-makedb
	cd $(SRCDIR)/data; $(TEST_BINDIR)/ngs-makedb

#-------------------------------------------------------------------------------
# test-ngs
#
TEST_NGS_SRC = \
	ngstest

TEST_NGS_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_NGS_SRC))

$(TEST_BINDIR)/test-ngs: $(TEST_NGS_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_NGS_LIB)

ngs: test-ngs
	$(TEST_BINDIR)/$^

#-------------------------------------------------------------------------------
# test-ngs_sra
#
TEST_NGS_SRA_SRC = \
	ngstest_sra

TEST_NGS_SRA_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_NGS_SRA_SRC))

$(TEST_BINDIR)/test-ngs_sra: $(TEST_NGS_SRA_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_NGS_LIB)

sra: test-ngs_sra
	$(TEST_BINDIR)/$^

#-------------------------------------------------------------------------------
# test-ngs_sradb
#
TEST_NGS_SRADB_SRC = \
	ngstest_sradb

TEST_NGS_SRADB_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_NGS_SRADB_SRC))

$(TEST_BINDIR)/test-ngs_sradb: $(TEST_NGS_SRADB_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_NGS_LIB)

sradb: test-ngs_sradb
	$(TEST_BINDIR)/$^

#-------------------------------------------------------------------------------
# test-ngs_csra1
#
TEST_NGS_CSRA1_SRC = \
	ngstest_csra1

TEST_NGS_CSRA1_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_NGS_CSRA1_SRC))

$(TEST_BINDIR)/test-ngs_csra1: $(TEST_NGS_CSRA1_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_NGS_LIB)

csra1: test-ngs_csra1
	$(TEST_BINDIR)/$^

#-------------------------------------------------------------------------------
# test-ngs_csra1_readcollection
#
TEST_NGS_CSRA1_READCOLLECTION_SRC = \
	ngstest_csra1_readcollection

TEST_NGS_CSRA1_READCOLLECTION_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_NGS_CSRA1_READCOLLECTION_SRC))

$(TEST_BINDIR)/test-ngs_csra1_readcollection: $(TEST_NGS_CSRA1_READCOLLECTION_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_NGS_LIB)

#-------------------------------------------------------------------------------
# test-ngs_csra1_refwin
#
TEST_NGS_CSRA1_REFWIN_SRC = \
	ngstest_csra1_refwin

TEST_NGS_CSRA1_REFWIN_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_NGS_CSRA1_REFWIN_SRC))

$(TEST_BINDIR)/test-ngs_csra1_refwin: $(TEST_NGS_CSRA1_REFWIN_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_NGS_LIB)

refwin: test-ngs_csra1_refwin
	$(TEST_BINDIR)/$^

#-------------------------------------------------------------------------------
# test-ngs_csra1_pileup
#
TEST_NGS_CSRA1_PILEUP_SRC = \
	ngstest_csra1_pileup

TEST_NGS_CSRA1_PILEUP_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_NGS_CSRA1_PILEUP_SRC))

$(TEST_BINDIR)/test-ngs_csra1_pileup: $(TEST_NGS_CSRA1_PILEUP_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_NGS_LIB)

#-------------------------------------------------------------------------------
# test-ngs_reference
#
TEST_NGS_REFERENCE_SRC = \
	ngstest_reference

TEST_NGS_REFERENCE_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_NGS_REFERENCE_SRC))

$(TEST_BINDIR)/test-ngs_reference: $(TEST_NGS_REFERENCE_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_NGS_LIB)

reference: test-ngs_reference
	$(TEST_BINDIR)/$^

#-------------------------------------------------------------------------------
# test-ngs_fragmentblob
#
TEST_NGS_SRC = \
	ngstest_fragmentblob

TEST_NGS_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_NGS_SRC))

$(TEST_BINDIR)/test-ngs_fragmentblob: $(TEST_NGS_OBJ) makedb
	$(LP) --exe -o $@ $^ $(TEST_NGS_LIB)

fragmentblob: test-ngs_fragmentblob
	cd $(SRCDIR); $(TEST_BINDIR)/$^

=== test/sraxf/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/sraxf

TEST_TOOLS = \
	test-fix_read_seg \

include $(TOP)/build/Makefile.env

$(TEST_TOOLS): makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@

.PHONY: $(TEST_TOOLS)

clean: stdclean

#----------------------------------------------------------------
# fix_read_seg-test
#

SRATEST_SRC = \
	fix_read_seg-test

SRATEST_OBJ = \
	$(addsuffix .$(OBJX),$(SRATEST_SRC))

SRATEST_LIB = \
	-skapp \
	-sktst \
	-sncbi-vdb \

$(TEST_BINDIR)/test-fix_read_seg: $(SRATEST_OBJ)
	$(LP) --exe -o $@ $^ $(SRATEST_LIB)

=== vdb3/src/kfc/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(abspath ../../..)
include $(TOP)/build/Makefile.config

# repairs to Makefile.config
INCDIRS = -I. -I$(TOP)/vdb3/itf

OBJFILES = \
	$(KFC_OBJ)

INTLIBS = \
	vdb3-kfc

EXTLIBS =   \

TARGETS =      \
	$(INTLIBS) \
	$(EXTLIBS)

# kernel-like facilities
KFC_SRC =    \
	rsrc     \
	pfdmgr   \
	fdmgr    \
	fd       \
	stream   \
	plogger  \
	log      \
	ptimemgr \
	pmemmgr  \
	syserr   \
	string   \
	timemgr  \
	time     \
	ptr      \
	array    \
	memmgr   \
	memory   \
	ref      \
	refcount \
	integer  \
	except   \
	callstk

# object files
KFC_OBJ = \
	$(addprefix $(OBJDIR)/,$(addsuffix .$(LOBX),$(KFC_SRC)))

all std: $(TARGETS)

compile: $(OBJDIR) $(OBJFILES)

clean:
	rm -rf $(ILIBDIR)/$(LPFX)ngs-disp* $(OBJDIR)

.PHONY: default all std $(TARGETS)

vdb3-kfc: $(ILIBDIR) $(OBJDIR) $(ILIBDIR)/$(LPFX)vdb3-kfc.$(LIBX)

# rule to produce the static library
$(ILIBDIR)/$(LPFX)vdb3-kfc.$(LIBX): $(KFC_OBJ)
	$(AR) $@ $^

=== debian/changelog ===
ncbi-vdb (2.8.1+dfsg-2~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.
  * Make sure jni.h will be really found
  * Brute-force libkapp building with -fPIC

 -- Andreas Tille <tille@debian.org>  Wed, 07 Jun 2017 13:57:51 +0200

ncbi-vdb (2.8.1+dfsg-2) unstable; urgency=medium

  * Fix install dir by using DEB_HOST_MULTIARCH instead of DEB_BUILD_GNU_TYPE
    (thanks for the patch to Graham Inggs <ginggs@debian.org>)
    Closes: #859260

 -- Andreas Tille <tille@debian.org>  Sat, 01 Apr 2017 22:50:01 +0200

ncbi-vdb (2.8.1+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Install libs/kfg/*.kfg into /usr/lib/ncbi-vdb/kfg/

 -- Andreas Tille <tille@debian.org>  Wed, 11 Jan 2017 15:27:16 +0100

ncbi-vdb (2.8.0+dfsg-2) unstable; urgency=medium

  * Make sure libraries are properly linked with libmbed
    Closes: #844900
  * Adjust dependencies from other development packages
  * debhelper 10
  * d/watch: version=4

 -- Andreas Tille <tille@debian.org>  Fri, 25 Nov 2016 12:41:49 +0100

ncbi-vdb (2.8.0+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Use wildcard instead of $(CPU) in install to fix FTBFS on i386 (thanks
    for the patch to Logan Rosen <logan@ubuntu.com>)
    Closes: #843129
  * New Build-Depends: libmbedtls-dev

 -- Andreas Tille <tille@debian.org>  Fri, 04 Nov 2016 10:15:13 +0100

=== debian/control ===
Source: ncbi-vdb
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 10),
               d-shlibs,
               libbz2-dev,
               libxml2-dev,
               libhdf5-dev,
               libmagic-dev,
               libngs-sdk-dev (>= 1.2.4),
               libngs-java,
               libmbedtls-dev,
               zlib1g-dev,
               openjdk-8-jdk-headless
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/ncbi-vdb.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/ncbi-vdb.git
Homepage: https://github.com/ncbi/ncbi-vdb

Package: libncbi-vdb2
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: libraries for using data in the INSDC Sequence Read Archives
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.

Package: libncbi-vdb-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libncbi-vdb2 (= ${binary:Version}),
         libkdf5-dev (= ${binary:Version}),
         libncbi-wvdb-dev (= ${binary:Version}),
         libaec-dev,
         libbz2-dev,
         zlib1g-dev
Description: libraries for using data in the INSDC Sequence Read Archives (devel)
 Much of the data submitted these days, for example in BAM, Illumina
 export.txt, and Complete Genomics formats, contain alignment
 information. With aligned data, NCBI uses Compression by Reference,
 which only stores the differences in base pairs between sequence data
 and the segment it aligns to. The process to restore original data, for
 example as FastQ, requires fast access to the reference sequences that
 the original data was aligned to. NCBI recommends that SRA users
 dedicate local disk space to store references downloaded from the NCBI
 SRA site. As of Fall 2014, the complete collection of these reference
 sequences is 66 GB. While it isn't usually necessary to download the
 entirety of the reference sequences, this should give you an idea of the
 scale of the storage requirement. By default, the Toolkit will download
 missing reference sequences on demand and cache them in the user's home
 directory. The location of this cache is configurable, as is whether the
 download is automatic or manual.
 .
 This is the development package.

Package: libkdf5-2
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libmbedtls-dev
Description: hdf5 access to data in the INSDC Sequence Read Archives
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 This library is part of the ncbi-vdb package and provides an interface
 to the Hierarchical Data Format 5 (HDF5).

Package: libkdf5-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libkdf5-2 (= ${binary:Version}),
Description: hdf5 access to data in the INSDC Sequence Read Archives (devel)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 This library is part of the ncbi-vdb package and provides an interface
 to the Hierarchical Data Format 5 (HDF5).
 .
 This is the development package.

Package: libncbi-wvdb2
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: virtual layer update modul of ncbi-vdb library
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 This library is part of the ncbi-vdb package.

Package: libncbi-wvdb-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libncbi-wvdb2 (= ${binary:Version}),
Description: virtual layer update modul of ncbi-vdb library (devel)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 This library is part of the ncbi-vdb package.
 .
 This is the development package.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

DEB_BUILD_OPTIONS := nocheck

# DH_VERBOSE := 1

DEBPKGNAME     := $(shell dpkg-parsechangelog | awk '/^Source:/ {print $$2}')

OS := $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS)
CPU := $(shell dpkg-architecture -qDEB_BUILD_GNU_CPU)
MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
# since build-results are not ending up in the proper dir its saver to use "*" instead of "$(CPU)"
SODIR := $(DEBPKGNAME)/$(DEBPKGNAME)/$(OS)/gcc
VDB_ARCH := $(word 1, $(subst -, ,$(DEB_HOST_MULTIARCH)))
LIBINSTALLDIR := debian/tmp/usr/$(DEBPKGNAME)/$(OS)/gcc/$(VDB_ARCH)/dbg/lib
LIBPKG := libncbi-vdb2
SCHEMADIR := debian/$(LIBPKG)/usr/lib/$(DEBPKGNAME)

%:
	dh $@

override_dh_auto_clean:
	if [ -e ngs-sdk/Makefile.config.$(OS).$(CPU) ] ; then \
		dh_auto_clean ; \
	fi
	rm -rf $(DEBPKGNAME)/$(MULTIARCH)

override_dh_auto_configure:
	# that's no standard configure script lacking support of default options
	# The build system shamelessly ignores those options like
	#    --with-ngs-java-prefix=/usr/share/java
	# so we need to go with patches.  The options are specified anyway.
	ln -s `ls /usr/lib/jvm/*/include/jni.h | head -n 1`		libs/ngs-jni
	ln -s `ls /usr/lib/jvm/*/include/linux/jni_md.h | head -n 1`	libs/ngs-jni
	./configure --build=$(MULTIARCH) --prefix=/usr --build-prefix=$(CURDIR)/debian/tmp/usr --with-ngs-sdk-prefix=/usr --with-debug --with-ngs-java-prefix=/usr/share/java
	# no idea how to convince configure script to use the correct include dir so patching result afterwards
	sed -i 's?HDF5_INCDIR = /usr/include?&/hdf5/serial?' build/Makefile.config*

override_dh_auto_test:
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	# FIXME: some tests keep on failing despite debian/patches/skip_failing_test.patch - needs to be sorted out later
	dh_auto_test || true
else
	echo "Skip testing which takes a long time"
endif

override_dh_auto_install:
	dh_auto_install
	find $(LIBINSTALLDIR) -name "*-static.a" -delete
	# upstream installs versioned *.a libs - we only want a single version
	for slib in $(LIBINSTALLDIR)/*.a ; do \
	    mv $(LIBINSTALLDIR)/`readlink $$slib` $$slib ; \
	    mv $(LIBINSTALLDIR)/`readlink $$slib` $$slib ; \
	done
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    --override s/libmbedcrypto0-dev/libmbedtls-dev/ \
		    --override s/libmbedtls10-dev/libmbedtls-dev/ \
		    --override s/libmbedx509-0-dev/libmbedtls-dev/ \
		    --movedev debian/tmp/usr/$(DEBPKGNAME)/$(OS)/gcc/*/dbg/lib/libncbi-ngs-c++.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEBPKGNAME)/$(OS)/gcc/*/dbg/ilib/libkapp.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEBPKGNAME)/$(OS)/gcc/*/dbg/ilib/libkapp-norsrc.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEBPKGNAME)/$(OS)/gcc/*/dbg/ilib/libkff.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEBPKGNAME)/$(OS)/gcc/*/dbg/ilib/libktst.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEBPKGNAME)/$(OS)/gcc/*/dbg/ilib/libkxfs.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEBPKGNAME)/$(OS)/gcc/*/dbg/ilib/libkxml.a usr/lib/$(MULTIARCH) \
                    --movedev debian/tmp/usr/$(DEBPKGNAME)/$(OS)/gcc/*/dbg/ilib/libload.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEBPKGNAME)/$(OS)/gcc/*/dbg/ilib/libtui.a usr/lib/$(MULTIARCH) \
                    --movedev debian/tmp/usr/$(DEBPKGNAME)/$(OS)/gcc/*/dbg/ilib/libtui_cpp.a usr/lib/$(MULTIARCH) \
		    --movedev interfaces usr/include \
		    debian/tmp/usr/$(DEBPKGNAME)/$(OS)/gcc/*/dbg/lib/libncbi-vdb.so
	mv debian/libncbi-vdb-dev/usr/include/interfaces debian/libncbi-vdb-dev/usr/include/$(DEBPKGNAME)
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    --override s/libhdf5_serial[0-9]*-dev/libhdf5-dev/ \
		    --override s/libmbedcrypto0-dev/libmbedtls-dev/ \
		    --override s/libmbedtls10-dev/libmbedtls-dev/ \
		    --override s/libmbedx509-0-dev/libmbedtls-dev/ \
		    debian/tmp/usr/$(DEBPKGNAME)/$(OS)/gcc/*/dbg/lib/libkdf5.so
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    debian/tmp/usr/$(DEBPKGNAME)/$(OS)/gcc/*/dbg/lib/libncbi-wvdb.so
	find debian/lib* -name .gitignore -delete
	# move schemata from development packages to library packages since these are used in executables
	mkdir -p $(SCHEMADIR)
	set -x ; \
	for schema in `find debian/libncbi-vdb-dev/usr/include/$(DEBPKGNAME) -name "*.vschema"` ; do \
	    schemafile=`basename $${schema}` ; \
	    schemadir=`basename $$(dirname $${schema})` ; \
	    mkdir -p $(SCHEMADIR)/$${schemadir} ; \
	    sed -i "s:^include ':&/usr/lib/ncbi-vdb/:" $${schema} ; \
	    mv $${schema} $(SCHEMADIR)/$${schemadir} ; \
	done
